; dmmConvertPNGtoJPG.scm - GIMP Script-Fu to Convert PNG to JPG
;    This Script-Fu must be put in The GIMP's script directory
;    (e.g., $HOME/.gimp-1.2/scripts).
;    For command-line invocation, use the shell script dmmConvertPNGtoJPG.sh
;    For interactive invocation, run The GIMP and go to
;    Xtns -> Script-Fu -> dmm
;

(define (saveScannedFile image drawable personalNumber prihlaskyDir fotkyDir)
  (let*
    (;(img (car (gimp-drawable-get-image image)))
;     (drawable (car (gimp-image-get-active-drawable image)))

;(set! adresar (car (opendir "d:\\scanned"))) ;http://pingus.seul.org/~grumbel/gimp/script-fu/script-fu-tut.html
;(set! soubor (readdir adresar)))
;(gimp-file-load 1 soubor soubor)

; ---------------------------------------------------------------------------------------- ;
; zkopirovani vyberu do noveho obrazku							   ;
; melo by fungovat (script-fu-selection-to-image 1 image drawable), ale nejak to nejde :(  ;
; ---------------------------------------------------------------------------------------- ;

;      (script-fu-selection-to-image 1 image drawable)
  (draw-type (car (gimp-drawable-type-with-alpha drawable)))
	 (image-type (car (gimp-image-base-type image)))
	 (selection-bounds (gimp-selection-bounds image))
	 (select-offset-x  (cadr selection-bounds))
	 (select-offset-y  (caddr selection-bounds))
	 (selection-width  (- (cadr (cddr selection-bounds)) select-offset-x))
	 (selection-height (- (caddr (cddr selection-bounds)) select-offset-y)))

    (gimp-context-push)

    (gimp-image-undo-disable image)
    
    (if (= (car (gimp-selection-is-empty image)) TRUE)
	(begin
	  (gimp-selection-layer-alpha drawable)
	  (set! active-selection (car (gimp-selection-save image)))
	  (set! from-selection FALSE))
	(begin
	  (set! from-selection TRUE)
	  (set! active-selection (car (gimp-selection-save image)))))

    (gimp-edit-copy drawable)

    (set! new-image (car (gimp-image-new selection-width
					 selection-height image-type)))
    (set! new-draw (car (gimp-layer-new new-image
					selection-width selection-height
					draw-type "Selection" 100 NORMAL-MODE)))
    (gimp-image-add-layer new-image new-draw 0)
    (gimp-drawable-fill new-draw BACKGROUND-FILL)

    (let ((floating-sel (car (gimp-edit-paste new-draw FALSE))))
      (gimp-floating-sel-anchor floating-sel))

    (gimp-image-undo-enable image)
    (gimp-image-set-active-layer image drawable)

;    (print new-image)
    
    (set! new-display (car (gimp-display-new new-image)))
;    (gimp-display-new new-image) ;mam obrazek, nemusim ho ale zobrazovat (mozna)
    (gimp-displays-flush)

    (gimp-context-pop)

; ----------------------------------------- ;
; tedka se da konecne neco zacit delat ...  ;
; ----------------------------------------- ;
;(gimp-message-set-handler 2) ;presmerovani debugu na error consoli
;(gimp-message "foo")

    ; odkazy na obrazky ktery chci ulozit
    (set! image-list (cadr (gimp-image-list)))
;    (gimp-message (print image-list))
    (set! original-display image)
    (set! selected-display new-display)

;    (set! original-image (aref image-list 1)) ;originalni obrazek
    (set! original-image image) ;proc ho zjistovat, kdyz ho mam asi predanej?
    (set! selected-image (aref image-list 0)) ;novy obrazek
    ;(set! original-drawable (car (gimp-image-get-active-drawable original-image))) ;originalni paleta
    (set! original-drawable drawable) ;proc si ji zjistovat, kdyz ji mam predanou jako hlavni parametr?
    (set! selected-drawable (car (gimp-image-get-active-drawable selected-image))) ;paleta noveho obrazku

;    (print original-image)
;    (print selected-image)
    
    ; uprava jmen adresaru a souboru
    (set! out-original (string-append prihlaskyDir "\\" personalNumber ".jpg"))    
    (set! out-selected (string-append fotkyDir personalNumber ".jpg"))
    
    (file-jpeg-save 1 original-image original-drawable out-original out-original 
              0.85 0 1 0 "Scanned original" 0 1 0 0 )
            ; 0.85 quality (float 0 <= x <= 1)
            ;      0 smoothing factor (0 <= x <= 1)
            ;        1 optimization of entropy encoding parameter (0/1)
            ;          1 enable progressive jpeg image loading (0/1)
            ;            "xxxx"  image comment
            ;                   0 subsampling option number
            ;                     1 force creation of a baseline JPEG
            ;                       0 frequency of restart markers 
            ;                         in rows, 0 = no restart markers
            ;                         0 DCT algoritm to use 
    (file-jpeg-save 1 original-image selected-drawable out-selected out-selected 
              0.85 0 1 0 "Cropped photo" 0 1 0 0 )

    ;vymazani pending operaci v obrazku, aby se pak zavrel bez kecu
    (gimp-image-clean-all selected-image)
    (gimp-image-clean-all original-image)

    ;zavreni obrazku
;    (gimp-display-delete selected-drawable)
;    (gimp-display-delete original-drawable)
;    (gimp-image-delete new-image) ;close the new image (made from the selection)
;    (gimp-image-delete image) ;close the new image (made from the select)
    (gimp-display-delete new-display) ;and also close the original display
    (gimp-display-delete original-display) 

   ) ;let
) ;define

;(define (for-each fun lst) 
;  (if (not (null? lst))
;      (begin
;	(fun (car lst))
;	(for-each fun (cdr lst)))
;      #t))

;(define (gimp-display-delete-list l)
;  (for-each gimp-display-delete l))

;(define (gimp-image-delete-list l)
;  (for-each gimp-image-delete l))

    
(script-fu-register                                 ; I always forget these ...
   "saveScannedFile"                             ; script name to register
   _"<Image>/JIS/saveScannedFiles" ; where it goes
   "Saves file from scanner in 2 versions to different folders" ; script description
   "Houmles"                             ; author
   "Copyright 2005 by Houmles; GNU GPL"  ; copyright
   "2005-07-11"                          ; date
   "*"
    SF-IMAGE      "Image"           0
    SF-DRAWABLE   "Drawable"        0
    SF-STRING   _"Rodne cislo"           ""
    SF-STRING   _"Prihlasky studenti"           "d:\\JIS\\jis_prvaci_2005\\prihlasky_studenti\\"
    SF-STRING	_"Fotky studenti"	  "d:\\JIS\\jis_prvaci_2005\\vyrezane_fotky\\"
;    SF-VALUE "Image sizex"  "100"
;    SF-VALUE "Image sizey"  "100"
;    SF-COLOR "Background:"	'(255 255 255)

)

